
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Layout_preferencesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layout_preferences = await db.layout_preferences.create(
            {
                id: data.id || undefined,
        
        preference_key: data.preference_key
        ||
        null
            ,
            
        value: data.value
        ||
        null
            ,
            
        updated_at_local: data.updated_at_local
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await layout_preferences.setUser( data.user || null, {
            transaction,
        });
        
        await layout_preferences.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return layout_preferences;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const layout_preferencesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                preference_key: item.preference_key
            ||
            null
            ,
            
                value: item.value
            ||
            null
            ,
            
                updated_at_local: item.updated_at_local
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const layout_preferences = await db.layout_preferences.bulkCreate(layout_preferencesData, { transaction });

        // For each item created, replace relation files
        

        return layout_preferences;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const layout_preferences = await db.layout_preferences.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.preference_key !== undefined) updatePayload.preference_key = data.preference_key;
        
        
        if (data.value !== undefined) updatePayload.value = data.value;
        
        
        if (data.updated_at_local !== undefined) updatePayload.updated_at_local = data.updated_at_local;
        
        
        updatePayload.updatedById = currentUser.id;

        await layout_preferences.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await layout_preferences.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await layout_preferences.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return layout_preferences;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const layout_preferences = await db.layout_preferences.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of layout_preferences) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of layout_preferences) {
                await record.destroy({transaction});
            }
        });


        return layout_preferences;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const layout_preferences = await db.layout_preferences.findByPk(id, options);

        await layout_preferences.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await layout_preferences.destroy({
            transaction
        });

        return layout_preferences;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const layout_preferences = await db.layout_preferences.findOne(
            { where },
            { transaction },
        );

        if (!layout_preferences) {
            return layout_preferences;
        }

        const output = layout_preferences.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await layout_preferences.getUser({
            transaction
        });
        
        
        output.organizations = await layout_preferences.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'layout_preferences',
                        'value',
                        filter.value,
                    ),
                };
            }
            

            
            

            
            if (filter.updated_at_localRange) {
                const [start, end] = filter.updated_at_localRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_at_local: {
                    ...where.updated_at_local,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_at_local: {
                    ...where.updated_at_local,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.preference_key) {
                where = {
                    ...where,
                preference_key: filter.preference_key,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.layout_preferences.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'layout_preferences',
                        'preference_key',
                        query,
                    ),
                ],
            };
        }

        const records = await db.layout_preferences.findAll({
            attributes: [ 'id', 'preference_key' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['preference_key', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.preference_key,
        }));
    }

    
};

